3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff|--ff-only] [--[no-]rebase|--rebase=preserve] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and integrate it/them with the current HEAD.'
13 set_reflog_action "pull${1+ $*}"
14 require_work_tree_exists
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
21 die "$(gettext "Pull is not possible because you have unmerged files.
22 Please, fix them up in the work tree, and then use 'git add/rm <file>'
23 as appropriate to mark resolution, or use 'git commit -a'.")"
25 die "$(gettext "Pull is not possible because you have unmerged files.")"
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32 Please, commit your changes before you can merge.")"
34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
38 test -z "$(git ls-files -u)" || die_conflict
39 test -f "$GIT_DIR/MERGE_HEAD" && die_merge
41 bool_or_string_config () {
42 git config --bool "$1" 2>/dev/null || git config "$1"
45 strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
46 log_arg= verbosity= progress= recurse_submodules= verify_signatures=
47 merge_args= edit= rebase_args=
48 curr_branch=$(git symbolic-ref -q HEAD)
49 curr_branch_short="${curr_branch#refs/heads/}"
50 rebase=$(bool_or_string_config branch.$curr_branch_short.rebase)
53 rebase=$(bool_or_string_config pull.rebase)
56 # Setup default fast-forward options via `pull.ff`
57 pull_ff=$(git config pull.ff)
75 verbosity="$verbosity -q" ;;
77 verbosity="$verbosity -v" ;;
79 progress=--progress ;;
81 progress=--no-progress ;;
82 -n|--no-stat|--no-summary)
88 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
89 no_commit=--no-commit ;;
90 --c|--co|--com|--comm|--commi|--commit)
96 --sq|--squ|--squa|--squas|--squash)
98 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
106 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
107 --strateg=*|--strategy=*|\
108 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
111 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
118 strategy_args="${strategy_args}-s $strategy "
125 xx="-X $(git rev-parse --sq-quote "$2")"
128 xx=$(git rev-parse --sq-quote "$1") ;;
130 merge_args="$merge_args$xx "
132 -r=*|--r=*|--re=*|--reb=*|--reba=*|--rebas=*|--rebase=*)
135 -r|--r|--re|--reb|--reba|--rebas|--rebase)
138 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
141 --recurse-submodules)
142 recurse_submodules=--recurse-submodules
144 --recurse-submodules=*)
145 recurse_submodules="$1"
147 --no-recurse-submodules)
148 recurse_submodules=--no-recurse-submodules
151 verify_signatures=--verify-signatures
153 --no-verify-signatures)
154 verify_signatures=--no-verify-signatures
156 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
163 # Pass thru anything that may be meant for fetch.
173 rebase_args=--preserve-merges
178 echo "Invalid value for --rebase, should be true, false, or preserve"
184 error_on_no_merge_candidates () {
189 -t|--t|--ta|--tag|--tags)
190 echo "It doesn't make sense to pull all tags; you probably meant:"
191 echo " git fetch --tags"
196 if test true = "$rebase"
205 upstream=$(git config "branch.$curr_branch_short.merge")
206 remote=$(git config "branch.$curr_branch_short.remote")
208 if [ $# -gt 1 ]; then
209 if [ "$rebase" = true ]; then
210 printf "There is no candidate for rebasing against "
212 printf "There are no candidates for merging "
214 echo "among the refs that you just fetched."
215 echo "Generally this means that you provided a wildcard refspec which had no"
216 echo "matches on the remote end."
217 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
218 echo "You asked to pull from the remote '$1', but did not specify"
219 echo "a branch. Because this is not the default configured remote"
220 echo "for your current branch, you must specify a branch on the command line."
221 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
223 error_on_missing_default_upstream "pull" $op_type $op_prep \
224 "git pull <remote> <branch>"
226 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
227 echo "from the remote, but no such ref was fetched."
232 test true = "$rebase" && {
233 if ! git rev-parse -q --verify HEAD >/dev/null
235 # On an unborn branch
236 if test -f "$GIT_DIR/index"
238 die "$(gettext "updating an unborn branch with changes added to the index")"
241 require_clean_work_tree "pull with rebase" "Please commit or stash them."
244 test -n "$curr_branch" &&
245 . git-parse-remote &&
246 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
247 oldremoteref=$(git merge-base --fork-point "$remoteref" $curr_branch 2>/dev/null)
249 orig_head=$(git rev-parse -q --verify HEAD)
250 git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
251 test -z "$dry_run" || exit 0
253 curr_head=$(git rev-parse -q --verify HEAD)
254 if test -n "$orig_head" && test "$curr_head" != "$orig_head"
256 # The fetch involved updating the current branch.
258 # The working tree and the index file is still based on the
259 # $orig_head commit, but we are merging into $curr_head.
260 # First update the working tree to match $curr_head.
262 eval_gettextln "Warning: fetch updated the current branch head.
263 Warning: fast-forwarding your working tree from
264 Warning: commit \$orig_head." >&2
265 git update-index -q --refresh
266 git read-tree -u -m "$orig_head" "$curr_head" ||
267 die "$(eval_gettext "Cannot fast-forward your working tree.
268 After making sure that you saved anything precious from
269 $ git diff \$orig_head
276 merge_head=$(sed -e '/ not-for-merge /d' \
277 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
280 case "$merge_head" in
282 error_on_no_merge_candidates "$@"
285 if test -z "$orig_head"
287 die "$(gettext "Cannot merge multiple branches into empty head")"
289 if test true = "$rebase"
291 die "$(gettext "Cannot rebase onto multiple branches")"
296 # Pulling into unborn branch: a shorthand for branching off
297 # FETCH_HEAD, for lazy typers.
298 if test -z "$orig_head"
300 # Two-way merge: we claim the index is based on an empty tree,
301 # and try to fast-forward to HEAD. This ensures we will not
302 # lose index/worktree changes that the user already made on
304 empty_tree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
305 git read-tree -m -u $empty_tree $merge_head &&
306 git update-ref -m "initial pull" HEAD $merge_head "$curr_head"
310 if test true = "$rebase"
312 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
313 if test "$oldremoteref" = "$o"
319 merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
322 eval="git-rebase $diffstat $strategy_args $merge_args $rebase_args $verbosity"
323 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
326 eval="git-merge $diffstat $no_commit $verify_signatures $edit $squash $no_ff $ff_only"
327 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
328 eval="$eval \"\$merge_name\" HEAD $merge_head"